/*  TP serveur WEB
 prog4.ino
 envoi d'une page Web sauvegardée dans la carte micro SD 
 */

#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>

File myFile;


// @ MAC du shield Ethernet
byte mac[] = { 
  0x90, 0xA2, 0xDA, 0x0D, 0x05, 0xEF };
// @ IP du shield
IPAddress ip(192,168,1, 60);
// port utilisé (par défaut 80 pour le protocole HTTP)
EthernetServer server(80);

void setup() {
  // configuration du port série pour la communication de l'Arduino avec le PC
  Serial.begin(9600);

  // démarrage de la connexion Ethernet
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
   pinMode(10, OUTPUT); // laisser la broche SS en sortie - obligatoire avec librairie SD
   
  if (!SD.begin(4)) {  // initialisation de la carte SD avec broche 4 en tant que CS - renvoie true/false

    Serial.println("initialization SD failed!");
    return;
  }
  Serial.println("initialization SD done.");
}

void loop()
{
  // crée un objet client basé sur le client connecté au serveur
  EthernetClient client = server.available();

  if (client) { // si le client existe 
    // message d'accueil dans le Terminal Série
    Serial.println ("Client present !"); 

    while (client.connected()) { // tant que le client est connecté

      if (client.available()) { // si des octets sont disponibles en lecture
        // le test est vrai si il y a au moins 1 octet disponible

          char c = client.read(); // lit l'octet suivant reçu du client (pour vider le buffer au fur à mesure !)

      } // --- fin client.available

      else { // si pas de caractères disponibles = requete client terminée

          // message Terminal Serie      
        Serial.println ("Reception requete terminee"); 

        // envoi d'une entete standard de réponse http
        client.println("HTTP/1.1 200 OK");
        client.println("Content-Type: text/html");
        client.println();

        // affiche chaines caractères simples
        myFile = SD.open("index.htm",FILE_READ);
          if (myFile) {
            // read from the file until there's nothing else in it:
            while (myFile.available()) {
               client.print(char(myFile.read()));
            }
            // close the file:
            myFile.close();
          }
          else {
  	    // if the file didn't open, print an error:
            Serial.println("error opening index.html");
        }
        // message Terminal Serie
        Serial.println ("Reponse envoyee au client"); 
        break; // on sort de la boucle while
      }
    }
    // on donne au navigateur le temps de recevoir les données
    delay(1);
    // fermeture de la connexion avec le client
    client.stop();
  } 
}

